%define BUILD_FOR_GCC2	 1
%define BUILD_FOR_GCC3_0 0
%define BUILD_FOR_GCC3_1 0
%define BUILD_FOR_GCC3_2 1

%define gcclibdir %_libdir/gcc-lib/%_target_platform

Name:		cppunit
Version:	1.8.0
Release:	alt4.1

Summary:	CppUnit is the C++ port of the famous JUnit framework for unit testing
License:	LGPL
Group:		Development/C++
Url:		http://sourceforge.net/projects/cppunit
Source0:	%name-%version.tar.bz2
Patch0:		%name-1.6.2-makefile.patch
Obsoletes:	%name-gcc2, %name-gcc3
Provides:	%name-gcc2 = %version-%release, %name-gcc3 = %version-%release

BuildRequires: XFree86-libs doxygen freetype graphviz libjpeg xpm

%if %BUILD_FOR_GCC2
BuildRequires: cpp gcc-c++ libstdc++-devel 
%endif
%if %BUILD_FOR_GCC3_0
BuildRequires: cpp3.0 gcc3.0-c++ libstdc++3.0-devel
%endif
%if %BUILD_FOR_GCC3_1
BuildRequires: cpp3.1 gcc3.1-c++ libstdc++3.1-devel
%endif
%if %BUILD_FOR_GCC3_2
BuildRequires: cpp3.2 gcc3.2-c++ libstdc++3.2-devel
%endif

%description
	CppUnit --- The C++ Unit Test Library
	-------------------------------------
	
CppUnit is the C++ port of the famous JUnit framework for unit
testing.

%package devel
Summary:	CppUnit is the C++ port of the famous JUnit framework for unit testing
Group:		Development/C++
Requires:	%name = %version-%release
Obsoletes:	%name-gcc2-devel, %name-gcc3-devel, %name-common-devel
Provides:	%name-gcc2 = %version-%release, %name-gcc3 = %version-%release, %name-common-devel = %version-%release

%description devel
	CppUnit --- The C++ Unit Test Library
	-------------------------------------
	
CppUnit is the C++ port of the famous JUnit framework for unit
testing.

%package devel-static
Summary:	CppUnit. Libraries for programs compiled with g++-2.x.x
Group:		Development/C++
Requires:	%name-devel = %version-%release

%description devel-static
	CppUnit --- The C++ Unit Test Library
	-------------------------------------
	
CppUnit is the C++ port of the famous JUnit framework for unit
testing.

%prep
%setup -q
%patch -p1


%buildmulti

BuildLibs()
{
	compiler="$1"
	suffix="$2"

	export CXX=g++-$compiler
	export LIBSUFFIX=$suffix
	%configure
	%make_build
	%make_install DESTDIR=$RPM_BUILD_ROOT install
	make distclean
}

%if %BUILD_FOR_GCC2
BuildLibs "2.96" "gcc2"
%endif
%if %BUILD_FOR_GCC3_0
BuildLibs "3.0.4" "gcc3.0"
%endif
%if %BUILD_FOR_GCC3_1
BuildLibs "3.1.1" "gcc3.1"
%endif
%if %BUILD_FOR_GCC3_2
BuildLibs "3.2" "gcc3.2"
%endif


%install
mkdir -p $RPM_BUILD_ROOT%_docdir
mv $RPM_BUILD_ROOT%_datadir/cppunit $RPM_BUILD_ROOT%_docdir/%name-%version/
mkdir -p $RPM_BUILD_ROOT%gcclibdir

CreateSymlinks()
{
	compiler="$1"
	suffix="$2"

	mkdir -p $RPM_BUILD_ROOT%gcclibdir/$compiler
	cd $RPM_BUILD_ROOT%gcclibdir/$compiler

	ln -s ../../../libcppunit-$suffix-1.8.so.0.0.0 libcppunit.so
	ln -s ../../../libcppunit-$suffix.a libcppunit.a
	ln -s ../../../libcppunit-$suffix.la libcppunit.la
}

%if %BUILD_FOR_GCC2
CreateSymlinks "2.95.3" "gcc2"
CreateSymlinks "2.96" "gcc2"
%endif
%if %BUILD_FOR_GCC3_0
CreateSymlinks "3.0.4" "gcc3.0"
%endif
%if %BUILD_FOR_GCC3_1
CreateSymlinks "3.1.1" "gcc3.1"
%endif
%if %BUILD_FOR_GCC3_2
CreateSymlinks "3.2.1" "gcc3.2"
%endif


%files
%_libdir/lib%name-*.so.*

%files devel
%dir %_includedir/cppunit
%_bindir/*
%_includedir/cppunit/*
%_datadir/aclocal/*
%_man1dir/*
%_docdir/%name-%version/*
%_libdir/lib%name-*.la
%gcclibdir/*/lib%name.so
%gcclibdir/*/lib%name.la

%files devel-static
%_libdir/lib%name-*.a
%gcclibdir/*/lib%name.a

%post -p /sbin/ldconfig
%postun  -p /sbin/ldconfig

%changelog
* Tue Sep 10 2002 Alexey Voinov <voins@voins.program.ru> 1.8.0-alt4.1
- fixed version number for gcc3.2
(this is temporary release)

* Mon Aug 19 2002 Alexey Voinov <voins@voins.program.ru> 1.8.0-alt4
- added macros to control compilers version for which to build library
- spec rewrite: subpackages rearranged, files rearranged
- use gcc-version specific directories instead of update-alternatives
- buildreqs fixed

* Mon Jun 10 2002 Alexey Voinov <voins@voins.program.ru> 1.8.0-alt3
- buildreqs fixed

* Thu Jun 06 2002 Alexey Voinov <voins@voins.program.ru> 1.8.0-alt2
- fixed names of .so in update-alternatives
- fixed permissions on cppunit-config*
- added cppunit/ui include directory

* Sun May 26 2002 Alexey Voinov <voins@voins.program.ru> 1.8.0-alt1
- new version (1.8.0)

* Mon May 20 2002 Alexey Voinov <voins@voins.program.ru> 1.6.2-alt0.2
- support for gcc-3.x.x/gcc-2.x.x
- support for alternatives

* Thu Dec 13 2001 Alexey Voinov <voins@voins.program.ru> 1.6.2-alt0.1
- initial build 


